package gregapi.oredict;

import gregapi.code.HashSetNoNulls;

import java.util.HashMap;
import java.util.Set;

/**
 * @author Gregorius Techneticies
 * 
 * Used to process Non-Material based OreDict Stuff faster, like a String switch/case kind of a deal.
 */
public abstract class OreDictListenerEvent_Names implements IOreDictListenerEvent {
	private final HashMap<String, Set<IOreDictListenerEvent>> NAME_EVENTS = new HashMap<String, Set<IOreDictListenerEvent>>();
	
	public OreDictListenerEvent_Names(OreDictPrefix aPrefix) {
		addAllListeners();
		aPrefix.addListener(this);
	}
	
	public OreDictListenerEvent_Names() {
		addAllListeners();
		OreDictManager.INSTANCE.addListener(this);
	}
	
	public abstract void addAllListeners();
	
	public boolean addListener(String aOreDictName, IOreDictListenerEvent aListener) {
		Set<IOreDictListenerEvent> tSet = NAME_EVENTS.get(aOreDictName);
		if (tSet == null) NAME_EVENTS.put(aOreDictName, tSet = new HashSetNoNulls<IOreDictListenerEvent>());
		return tSet.add(aListener);
	}
	
	public boolean addListener(String aOreDictName1, String aOreDictName2, IOreDictListenerEvent aListener) {
		return addListener(aOreDictName1, aListener) && addListener(aOreDictName2, aListener);
	}
	public boolean addListener(String aOreDictName1, String aOreDictName2, String aOreDictName3, IOreDictListenerEvent aListener) {
		return addListener(aOreDictName1, aListener) && addListener(aOreDictName2, aListener) && addListener(aOreDictName3, aListener);
	}
	public boolean addListener(String aOreDictName1, String aOreDictName2, String aOreDictName3, String aOreDictName4, IOreDictListenerEvent aListener) {
		return addListener(aOreDictName1, aListener) && addListener(aOreDictName2, aListener) && addListener(aOreDictName3, aListener) && addListener(aOreDictName4, aListener);
	}
	
	@Override
	public void onOreRegistration(OreDictRegistrationContainer aEvent) {
		Set<IOreDictListenerEvent> tSet = NAME_EVENTS.get(aEvent.mOreDictName);
		if (tSet != null) for (IOreDictListenerEvent tListener : tSet) tListener.onOreRegistration(aEvent);
	}
}