package gregapi.tileentity.energy;

import static gregapi.data.CS.ALONG_AXIS;
import static gregapi.data.CS.F;
import static gregapi.data.CS.OPPOSITES;
import static gregapi.data.CS.SIDE_ANY;
import gregapi.data.LH;
import gregapi.data.TD;
import gregapi.tileentity.machines.ITileEntitySwitchableOnOff;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.item.ItemStack;

public abstract class TileEntityBase11Bipolar extends TileEntityBase10EnergyConverter implements ITileEntitySwitchableOnOff {
	@Override
	public void addToolTipsEfficiency(List aList, ItemStack aStack, boolean aF3_H) {
		if (TD.Energy.ALL_EU.contains(mEnergyTypeAccepted)) {
			if (TD.Energy.ALL_EU.contains(mEnergyTypeEmitted)) {
				aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput, mOutput*2, F)));
			} else {
				if (mEnergyTypeEmitted == TD.Energy.RF) aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput*4, mOutput*2, F)));
			}
		} else {
			if (TD.Energy.ALL_EU.contains(mEnergyTypeEmitted) && mEnergyTypeAccepted == TD.Energy.RF) aList.add(LH.getToolTipEfficiency(UT.Code.units(10000, mInput, mOutput*8, F)));
		}
	}
	
    @Override
    public void doConversion(long aTimer) {
    	long tOutput = UT.Code.units(mEnergy, mInput, mOutput, F);
    	mActive = (tOutput >= getEnergySizeOutputMin(mEnergyTypeEmitted, SIDE_ANY));
		mEmitsEnergy = F;
    	
    	if (mActive) {
    		if (tOutput > getEnergySizeOutputMax(mEnergyTypeEmitted, SIDE_ANY)) {
    			overcharge(mEnergy, mEnergyTypeAccepted);
    		} else {
        		mEmitsEnergy = (ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted,           mFacing ,  tOutput, 1, this) > 0);
        		mEmitsEnergy = (ITileEntityEnergy.Util.emitEnergyToSide(mEnergyTypeEmitted, OPPOSITES[mFacing], -tOutput, 1, this) > 0) || mEmitsEnergy;
    		}
    	}
    	
		mEnergy = 0;
    }
    
	@Override public boolean isInput (byte aSide) {return !ALONG_AXIS[aSide][mFacing];}
	@Override public boolean isOutput(byte aSide) {return  ALONG_AXIS[aSide][mFacing];}
	@Override public String getLocalisedInputSide () {return LH.get(LH.FACE_ANYBUT_FRONT_BACK);}
	@Override public String getLocalisedOutputSide() {return LH.get(LH.FACE_FRONT_BACK);}
}